#!/bin/perl -w
use strict;
use CGI::Carp qw(fatalsToBrowser); 
use URI::Escape;
use Digest::MD5 qw(md5_hex);
use Time::HiRes qw(tv_interval gettimeofday);

my $t0 = [gettimeofday];

# Configuration
my $PULKOCMS_ROOT = "/var/www/pulkocms/";
my $WEB_ROOT = "";

##############################################################"

# Init : get the query
# GET
my @QUERY = split(/&/, $ENV{'QUERY_STRING'});
my %query;
foreach my $i (@QUERY) 
{
	my $mydata;
	my $varname;
	($varname, $mydata) = split(/=/, $i);
	$query{$varname} = $mydata ;
}
# POST
my $line;
read(STDIN, $line, $ENV{'CONTENT_LENGTH'});
@QUERY = split(/&/, $line);
foreach my $i (@QUERY) 
{
	my $mydata;
	my $varname;
	($varname, $mydata) = split(/=/, $i);
	$query{$varname} = $mydata ;
}

my $PULKOCMS_CAT=uri_unescape($query{"cat"});
my $PULKOCMS_NODE=uri_unescape($query{"node"});

print "Content-Type: text/html\n\n";
print <<ENDHTML;
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta name="keywords" content="" />
<meta name="description" content="" />
<meta http-equiv="content-type" content="text/html; charset=ISO-8859-1" />
<title>PulkoMandy's home on the web</title>
<link href="/style.css" rel="stylesheet" type="text/css" media="screen" />
</head>
<body>
	<div id="header">
		<div id="logo">
			<h1><a href="#">PulkoMandy's home on the web</a></h1>
			<p>Astuces, bidouilles, et plein d'autres trucs super!</p>
		</div>
	</div>
	<!-- end #header -->
	<div id="menu">
		<ul>
			<li><a href="$WEB_ROOT">Articles</a></li>
			<li><a href="$WEB_ROOT/_photos/_/_/">Photos</a></li>
			<li><a href="$WEB_ROOT/_/_.links/_links">Links</a></li>
			<li><a href="$WEB_ROOT/_/_.users/_PulkoMandy">Contact</a></li>
		</ul>
	</div>
	<!-- end #menu -->
	<div id="page">
		<div id="content">
ENDHTML
;

sub Display_Article
{
		my $art = $_[0];
		open(ARTICLE,"$PULKOCMS_ROOT/cat$PULKOCMS_NODE/$PULKOCMS_CAT/$art.article")
			or die("$PULKOCMS_ROOT/cat$PULKOCMS_NODE/$PULKOCMS_CAT/$art.article: $!");
		my ($dev,$ino,$mode,$nlink,$uid,$gid,$rdev,$size,$atime,$mtime,$ctime,$blksize,$blocks)
			= stat("$PULKOCMS_ROOT/cat$PULKOCMS_NODE/$PULKOCMS_CAT/$art.article");
		my @user  = getpwuid($uid);
		my $author = $user[6];
		$author =~ s/[^a-zA-Z0-9 ]*//g;
		my $date = scalar(localtime($mtime));
		my $count = 0;
		my $escart = uri_escape($art);
		my $comfile= "$PULKOCMS_ROOT/cat$PULKOCMS_NODE/$PULKOCMS_CAT/$escart.comment";
		if(open(COMMENTS,$comfile))
		{
			my $buffer;
			while (sysread COMMENTS, $buffer, 4096) {
        			$count += ($buffer =~ tr/\n//);
    			}
			close(COMMENTS);
		}
		else
		{
				$count = 0;
		}
		print <<ENDHTML;
		<div class="post">
				<div class="post-bgtop">
				<div class="post-bgbtm">
				<h2 class="title"><a href="$WEB_ROOT/_$query{"node"}/_$query{"cat"}/_$art">$art</a></h2>
				<p class="meta">Posted by <a href="$WEB_ROOT/_/_.users/_$author">$author</a> on $date
				&nbsp;&bull;&nbsp; <a href="$WEB_ROOT/_$query{"node"}/_$query{"cat"}/_$art" class="comments">Comments ($count)</a> &nbsp;&bull;&nbsp;</p>
				<div class="entry">
ENDHTML
				;
		if(-e "$PULKOCMS_ROOT/cat$PULKOCMS_NODE/$PULKOCMS_CAT/$art.jpg")
		{
			print "<p><img src=\"$WEB_ROOT/pulkocms/cat$PULKOCMS_NODE/$PULKOCMS_CAT/$art.jpg\" alt=\"\" /></p>";
		}
		while(<ARTICLE>)
		{
				print $_ ;
		}
		print <<ENDHTML;
				</div>
				</div>
				</div>
		</div>
ENDHTML
				;
		close(ARTICLE);
}

sub Compare_date ($$)
{
	my ($dev,$ino,$mode,$nlink,$uid,$gid,$rdev,$size,$atime,$mtime,$ctime,$blksize,$blocks)  = stat("$PULKOCMS_ROOT/cat/$PULKOCMS_CAT/$_[0]");
	my ($dev,$ino,$mode,$nlink,$uid,$gid,$rdev,$size,$atime,$mtimeB,$ctime,$blksize,$blocks)  = stat("$PULKOCMS_ROOT/cat/$PULKOCMS_CAT/$_[1]");

	return $mtimeB <=> $mtime;
}

# ARTICLE VIEW
# If an article name is specified, display only this one, but add the comments
if($query{"art"})
{
	my $art = uri_unescape($query{"art"});
	Display_Article($art);

	# New message ?
	my $comment_file = "$PULKOCMS_ROOT/cat$PULKOCMS_NODE/$PULKOCMS_CAT/$query{\"art\"}.comment";
	if($query{"comment"} && $query{"who"})
	{
		# Check that the articles exists
		if(! -e "$PULKOCMS_ROOT/cat$PULKOCMS_NODE/$PULKOCMS_CAT/$art.article") { die("You are an EVIL HACKER !"); }
		my $who = uri_unescape($query{"who"});
		my $mail = uri_unescape($query{"mail"});
		$who =~ s/\+/ /g;
		$who =~ s/\<[^\<]+\>//g;
		my $comment = uri_unescape($query{"comment"});
		$comment =~ s/\+/ /g;
		$comment =~ s/\n/<br\/>/g;
		$comment =~ s/\<[^\<]+\>//g;
		open(COMMENT,">>",$comment_file) or die $! ;
		my ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime() ;
		$year += 1900;
		$mon += 1;
		my $date = scalar localtime();
		print COMMENT "$who\0$date\0$comment\0$mail\n";
		close(COMMENT);

		open(COMMENT,">>","$PULKOCMS_ROOT/recentcomments") or die $!;
		print COMMENT "<a href=\"$WEB_ROOT/_$query{\"node\"}/_$query{\"cat\"}/_$art\">$art</a> ($mday/$mon/$year)<span>$who</span>";
		close(COMMENT);
	}

	# read existing messages
	if(open(COMMENT,$comment_file))
	{
		while(<COMMENT>)
		{
			chop ; # remove the \n
			my @comment=split(/\0/,$_);
 			my $grav_url = "http://www.gravatar.com/avatar.php?gravatar_id=".md5_hex( lc $comment[3] )."&amp;size=30";
print <<ENDHTML;
		<div class="post">
				<div class="post-bgtop">
				<div class="post-bgbtm">
				<h2 class="title" style="padding-top: 0px; padding-left: 0px; height: 30px;">
					<img src="$grav_url" alt="gravatar" style="vertical-align: middle;"/>
					Comment
				</h2>
				<p class="meta">
					Posted by $comment[0] on $comment[1]
				</p>
				<div class="entry">
					$comment[2]
				</div></div></div>
		</div>
ENDHTML
;
		}
		close(COMMENT);
	}
print <<ENDHTML;
		<div class="post">
				<div class="post-bgtop">
				<div class="post-bgbtm">
				<h2 class="title">Leave a comment</h2>
				<div class="entry">
<form action="?node=$query{"node"}&amp;cat=$query{"cat"}&amp;art=$query{"art"}" method="post">
<p>Name: <input name="who" maxlength="12" size="12" />
 Mail: <input name="mail" maxlength="30" size="30" /></p>
<p><textarea name="comment" rows="10" cols="80"></textarea></p>
<p><input type="submit" value="Comment" /></p>
</form>
				</div></div></div>
		</div>
ENDHTML
;
}
else
{
# CATEGORY VIEW
# Get the articles for current category
# Note, it is possible to nest categories just by putting / between their names.
		if($PULKOCMS_CAT)
		{
				die("ERROR $!") unless opendir(CATDIR, "$PULKOCMS_ROOT/cat$PULKOCMS_NODE/".$PULKOCMS_CAT);
		}
		else
		{
				die("ERROR $!: $PULKOCMS_ROOT/cat$PULKOCMS_NODE")
					unless opendir(CATDIR, "$PULKOCMS_ROOT/cat$PULKOCMS_NODE");
		}
		my @Cat= readdir(CATDIR);
		closedir(CATDIR);
		my @Articles;
		if(@Cat)
		{
				@Articles = grep(/\.article$/,@Cat);
				@Articles = sort Compare_date @Articles ;
		}
		if(@Articles)
		{
				foreach(@Articles)
				{
					$_ = substr($_,0,-8);
					Display_Article($_);
				}
		}
		else
		{
				print("<p>This category is empty</p>\n");
		}
}
		print <<ENDHTML;
		<div style="clear: both;">&nbsp;</div>
				</div>
				<!-- end #content -->
<div id="sidebar">
<ul>
<li>
<h2>Categories</h2>
<ul>
ENDHTML
;

# Categories
# List categories = folders in ROOT/cat/
# Count .article files in each category.
# get cat.desc file in each category to display the short description
# category whose name stats with . are ignored (so are . and ..)
die("ERROR $!") unless opendir(DIR, "$PULKOCMS_ROOT/cat$PULKOCMS_NODE");
my @Categories= readdir(DIR);
closedir(DIR);
foreach(@Categories)
{
		if(substr($_,0,1) ne '.' && -d "$PULKOCMS_ROOT/cat$PULKOCMS_NODE/$_")
		{
			die("ERROR $!") unless opendir(CATDIR, "$PULKOCMS_ROOT/cat$PULKOCMS_NODE/$_");
			my @Articles=readdir(CATDIR);
			closedir(CATDIR);
			my @LIST = grep(/\.article$/,@Articles);
			my $nbart = @LIST ;
			print "<li><a href=\"$WEB_ROOT/_$query{\"node\"}/_$_/_/\">$_</a> ($nbart)<span>";
			open(DESC,"< $PULKOCMS_ROOT/cat$PULKOCMS_NODE/$_/cat.desc") or die("Could not get cat description for $_ : $!");
			while (<DESC>) {
					print "$_";
			}
			close(DESC);
			print("</span></li>\n");
		}
}
if(open(COMMENT,"$PULKOCMS_ROOT/recentcomments"))
{
	print <<ENDHTML;
	</ul>
		</li>
		<li>
		<h2>Recent comments</h2>
		<ul>
ENDHTML
		;
	while(<COMMENT>)
	{
		print "<li>$_</li>\n" ;
	}
	close(COMMENT);
}
print <<ENDHTML;
</ul>
</li>
<li>
<h2>Shoutbox</h2>
<ul>
ENDHTML
;
# SHOUTBOX
# New message ?
if($query{"shout"} && $query{"who"})
{
		my $who = uri_unescape($query{"who"});
		$who =~ s/\+/ /g;
		$who =~ s/\<[^\<]+\>//g;
		my $shout = uri_unescape($query{"shout"});
		$shout =~ s/\+/ /g;
		$shout =~ s/\<[^\<]+\>//g;
		open(SHOUTBOX,">>","$PULKOCMS_ROOT/shoutbox") or die $! ;
		if ($who eq "Grim")
		{
			print SHOUTBOX "$who<span style=\"font-size: 70%\">$shout</span>\n";
		}
		else
		{
			print SHOUTBOX "$who<span>$shout</span>\n";
		}
		close(SHOUTBOX);
}
# Only keep 10 lines
`sed -i -e ':a' -e '\$q;N;11,\$D;ba' /var/www/pulkocms/shoutbox` ;
`sed -i -e ':a' -e '\$q;N;11,\$D;ba' /var/www/pulkocms/recentcomments` ;
open(SHOUTBOX,"$PULKOCMS_ROOT/shoutbox") or die $! ;
while(<SHOUTBOX>)
{
		print "<li>$_</li>\n" ;
}
close(SHOUTBOX);
my $elapsed = tv_interval ( $t0 );
print <<ENDHTML;
<li>
<form action="" method="post">
<p style="margin: 0; padding:0"><input name="who" maxlength="12" size="6" style="font-size: 11px"/>
<input name="shout" maxlength="70" size="15" style="font-size: 11px"/>
<input type="submit" value="SHOUT!" style="font-size: 10px" /></p>
</form>
</li>
</ul>
</li>
</ul>
</div>
<!-- end #sidebar -->
<div style="clear: both;">&nbsp;</div>
</div>
<!-- end #page -->
<div id="footer">
<p>
<a href="http://jigsaw.w3.org/css-validator/check/referer">
    <img style="float: left;"
        src="http://jigsaw.w3.org/css-validator/images/vcss-blue"
        alt="CSS Valide !" /></a>
<a href="http://validator.w3.org/check?uri=referer">
<img style="float:right"
        src="http://www.w3.org/Icons/valid-xhtml10-blue"
        alt="Valid XHTML 1.0 Strict" /></a>
	<span>Powered by PulkoCMS v0.8<br/>
	Theme Watermelon, design by PulkoMandy<br/>
	Script run time: $elapsed seconds</span>
</p>
</div>
<!-- end #footer -->
</body>
</html>
ENDHTML
;
################################################################################
